
% Author: Dong-Ok Won
% Date: 2015-03-02
% File Name: HF_SSVEP_speller_experiment.m


%% setting
clear all, close all, clc
% fclose(t);
%Screen('CloseAll');

%bbci toolbox setting
startup_bbci
IO_ADDR=hex2dec('C050');

%% setting
try
    % Ready
    [sound_ready, Fs, nbits]  = wavread('E:/ssvep_led_dutycycle_design/alphabet/sound_ready.wav');
    % one minute rest
    [sound_rest, Fs, nbits] = wavread('E:/ssvep_led_dutycycle_design/alphabet/sound_one_minute_rest.wav');
    % Dtmf-pound bee
    [sound_beep, Fss, nbits] = wavread('E:/ssvep_led_dutycycle_design/data/new_low_m1.wav');
    %Thank_you_for_your_attention
%     [sound_thank, Fs, nbits] = wavread('E:/ssvep_led_dutycycle_design/alphabet/Thank_you_for_your_attention.wav');
    %Thank_you_for_your_attention
%     [sound_cross, Fs, nbits] = wavread('E:/ssvep_led_dutycycle_design/alphabet/cross.wav');
    

   
%     sprintf('D:/raw/bbciMat_201309/201309_2/%s/%s.mat', char(session(sub)), char(session(sub))))
    
    spell = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', ...
             'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', ...
             'U', 'V', 'W', 'X', 'Y', 'Z', '.', '<', '_', '/'];
%     sound_alpha=[];
    for alpha=1:26
        sound_address = sprintf('E:/ssvep_led_dutycycle_design/alphabet/%s.wav',spell(alpha));
        [sound_,Fsss, nbits]= wavread(sound_address);
        sound_alpha(1:length(sound_),alpha) = sound_;
    end
    
    sound_= wavread('E:/ssvep_led_dutycycle_design/alphabet/dot.wav');
    sound_alpha(1:length(sound_),27) = sound_;
    sound_= wavread('E:/ssvep_led_dutycycle_design/alphabet/backspace.wav');
    sound_alpha(1:length(sound_),28) = sound_;
    sound_= wavread('E:/ssvep_led_dutycycle_design/alphabet/space.wav');
    sound_alpha(1:length(sound_),29) = sound_;
    sound_= wavread('E:/ssvep_led_dutycycle_design/alphabet/enter.wav');
    sound_alpha(1:length(sound_),30) = sound_;

    %Predefine frequency (26~35, 0.3hz)
    %selection duty
    Duty = ['50'];
    Duty_off = ['00'];
    
     % rand_trial
    for i =1:16
        rand_trial(i,:) = randperm(30);
        for j=1:30
            rand_spell(i,j) = spell(rand_trial(i,j));
        end
    end
    
catch
    err_str = 'setting error!'
end
%% TCP/IP setting
try
%TCP/IP 
%Server
t=tcpip('localhost', 6340, 'NetworkRole', 'server');
fopen(t);
catch
    err_str = 'TCP/IP setting error!'
end
% fclose(t);
% delete(t);
%% psychtoolbox setting
try
    speller_size = [6 6];
    n_text_size = 56;

     train_char1 = ['BRAIN_COMPUTER_INTERFACE']; %characters to be trained
%     train_char2 = ['KOREA_UNIVERSITY']; %characters to be trained
%     train_char3 = ['STEADY_STATE_VISUAL_EVOKED_POTENTIAL'];

    screenNum = 1; %For Laptop
    
    screens = Screen('Screens');
    [w, rect] = Screen('OpenWindow', screenNum);
    loc_layout = proc_getlayout(speller_size, rect);
     black = BlackIndex(w);
%     white = WhiteIndex(w);
     Screen('FillRect', w, black);
%     slack = Screen('GetFlipInterval', w)/2;
%     vbl = Screen(w, 'Flip');
    %show
    normal_layout(w, rand_spell(1,:), ' ', loc_layout, 56, 0);
    begin_onset = Screen('Flip', w);
catch
    err_str = 'psychtoolbox setting error!'
end
%%
%Labview start

%% Run
pause(4);
%cue : look at the screen center
focus_cross(w,'+',70);
% begin_onset = Screen('Flip', w);
ppTrigger(101);
pause(60);

% %wait for any keyboard press
% pause;
% %wait for any keyboard & mouse press at figure
% waitforbuttonpress;

try
    %Run 1~5
    for i=1:16
        i
        %odd subject
        %2 sequence * 8(low, high, high, low, 65, 80, 65, 80)
        if i<9
            Duty = ['50'];
        end
%         switch(i)% odd subject
%             case 9
%                 Duty = ['65'];
%             case 11
%                 Duty = ['80'];
%             case 13
%                 Duty = ['80'];
%             case 15
%                 Duty = ['65'];
%         end
% %         
        switch(i)% even subject 
            case 9
                Duty = ['80'];
            case 11
                Duty = ['65'];
            case 13
                Duty = ['65'];
            case 15
                Duty = ['80'];
        end
        tcp_num = Duty;
        tcp_num_string =  char(tcp_num);
       %tcp/ip communication
        fwrite(t,tcp_num_string, 'char')
        
         %char change 
%         train_char1 = rand_spell(i,:);
%         n_text_size = 56;
       
        j= 1;
        %visual cue
        normal_layout(w, train_char1, ' ', loc_layout, n_text_size, j-1);
        begin_onset = Screen('Flip', w);
        pause(3);

        
        for j= 1:length(train_char1)
            j
            if j==1
                sound(sound_ready,Fs);%ready
            end
            
            %visual response
            normal_layout(w, train_char1, ' ', loc_layout, n_text_size, j-1);
            begin_onset = Screen('Flip', w);
            
            %sound cue
            alphabet_location = find(train_char1(j)==spell)
%             if alphabet_location<27
            sound(sound_alpha(:,alphabet_location),Fs);%Cue  
%             end

            
            %trigger
            ppTrigger(alphabet_location)
          
            %recoding time
            pause(5);
             
            sound(sound_beep,Fss)% 1s
            normal_layout(w, train_char1, ' ', loc_layout, n_text_size, j);
            begin_onset = Screen('Flip', w);
             
            pause(1.5);

        end
        
        fwrite(t,Duty_off, 'char') %LED Off
        
        normal_layout(w, train_char1, ' ', loc_layout, n_text_size, length(train_char1));
        begin_onset = Screen('Flip', w);
        pause(1);
        
        if i<17
            %cue : look at the screen center
            focus_cross(w,'+',70);
            %       begin_onset = Screen('Flip', w);
            ppTrigger(101);
            
            sound(sound_rest,Fs);% one minute rest
            i
            pause(60);
        end
        anykey(w, rect, n_text_size)
        begin_onset = Screen('Flip', w);
        pause;
    end
    
%     sound(sound_thank,Fs);%Thank_you,
    Screen('CloseAll');
catch
        err_str = 'experiment error!'
end

%Thank_you_for_your_attention

%The end
% fwrite(t,tcp_num, 'char') 
fclose(t);
delete(t);
% 
clear t 
clear all
clc
